## net.sf.saxon.expr
Class Atomizer

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.Atomizer

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class Atomizer

extends UnaryExpression

An Atomizer is an expression corresponding essentially to the fn:data() function: it maps a sequence by replacing nodes with their typed values

See Also:
  Serialized Form

Nested Class Summary
`static class` `Atomizer.AtomizingFunction` Implement the mapping function.

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Atomizer(Expression sequence, Configuration config)` Constructor

Method Summary
`int` `computeCardinality()` Determine the static cardinality of the expression
`int` `computeSpecialProperties()` Determine the special properties of this expression
`Item` `evaluateItem(XPathContext context)` Evaluate as an Item.
`static ItemType` `getAtomizedItemType(Expression operand, boolean alwaysUntyped, TypeHierarchy th)` Compute the type that will result from atomizing the result of a given expression
`static SequenceIterator` `getAtomizingIterator(SequenceIterator base)` Get an iterator that returns the result of atomizing the sequence delivered by the supplied iterator
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
`SequenceIterator` `iterate(XPathContext context)` Iterate over the sequence of values
`Expression` `simplify(StaticContext env)` Simplify an expression
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`display, equals, getBaseExpression, hashCode, iterateSubExpressions, optimize, promote, replaceSubExpression`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Atomizer

    public Atomizer(Expression sequence,
                    Configuration config)

  Constructor

  Parameters:
    `sequence` - the sequence to be atomized
    `config` - the Configuration. Used only for optimization, may be null. Atomization is faster if it is known in advance that all nodes will be untyped.

Method Detail

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `UnaryExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an Item. This should only be called if the Atomizer has cardinality zero-or-one, which will only be the case if the underlying expression has cardinality zero-or-one.

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression, if possible

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` -
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER. For this class, the result is always an atomic type, but it might be more specific.

### getAtomizedItemType

    public static final ItemType getAtomizedItemType(Expression operand,
                                                     boolean alwaysUntyped,
                                                     TypeHierarchy th)

  Compute the type that will result from atomizing the result of a given expression

  Parameters:
    `operand` - the given expression
    `alwaysUntyped` - true if it is known that nodes will always be untyped
  Returns:
    the item type of the result of evaluating the operand expression, after atomization

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`

### getAtomizingIterator

    public static SequenceIterator getAtomizingIterator(SequenceIterator base)

  Get an iterator that returns the result of atomizing the sequence delivered by the supplied iterator

  Parameters:
    `base` - the supplied iterator, the input to atomization
  Returns:
    an iterator that returns atomic values, the result of the atomization

Copyright (C) Michael H. Kay. All rights reserved.